#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif

#include <DS1302.h>
#include <avr/io.h>
#include <util/delay.h>
#include "TM1637.h"

#define PIN 6
#define RST PIN_PB2
#define DAT PIN_PB3
#define CLK PIN_PB4
#define CLK_7Seg PIN_PC3
#define DIO PIN_PC2

Adafruit_NeoPixel strip = Adafruit_NeoPixel(60, PIN, NEO_GRB + NEO_KHZ800);

DS1302 rtc(RST, DAT, CLK);

TM1637 tm1637(CLK_7Seg,DIO);

char *TimeStr;
int8_t Num[6];

void setup() {
  #if defined (__AVR_ATtiny85__)
    if (F_CPU == 16000000) clock_prescale_set(clock_div_1);
  #endif


  strip.begin();
  strip.show(); // Initialize all pixels to 'off'

  rtc.halt(false);
  rtc.writeProtect(false);
  //rtc.setTime(22, 20, 00);

  Serial.begin(9600);
  
  tm1637.init();
  tm1637.set(BRIGHT_TYPICAL);//BRIGHT_TYPICAL = 2,BRIGHT_DARKEST = 0,BRIGHTEST = 7;
  tm1637.point(POINT_ON);
}


void loop() {
  TimeStr = rtc.getTimeStr();
  Num[0] = TimeStr[0]-'0';
  Num[1] = TimeStr[1]-'0';
  Num[2] = TimeStr[3]-'0';
  Num[3] = TimeStr[4]-'0';
  Num[4] = TimeStr[6]-'0';
  Num[5] = TimeStr[7]-'0';
  Serial.println(rtc.getTimeStr());
  colorWipeSmall(strip.Color(2, 2, 0), Num[4]);
  colorWipeBig(strip.Color(1, 1, 2), Num[4], Num[5]);
  tm1637.display(0, Num[0]);
  tm1637.display(1, Num[1]);
  tm1637.display(2, Num[2]);
  tm1637.display(3, Num[3]);
  delay(300);
}

void colorWipeBig(uint32_t c, uint8_t ft, uint8_t nd) {
  if(ft == 0 && nd == 0) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(7, 0);
    strip.setPixelColor(8, 0);
    strip.setPixelColor(9, 0);
    strip.setPixelColor(10, 0);
    strip.setPixelColor(11, 0);
    strip.setPixelColor(12, 0);
    strip.setPixelColor(13, 0);
    strip.setPixelColor(14, 0);
    strip.setPixelColor(15, 0);
    strip.setPixelColor(17, 0);
    strip.setPixelColor(18, 0);
    strip.show();
  } 
   if(ft == 0 && nd == 5) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.show();
  } 
   if(ft == 1 && nd == 0) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.show();
  } 
   if(ft == 1 && nd == 5) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.setPixelColor(7, strip.Color(2, 2, 0));
    strip.show();
  } 
   if(ft == 2 && nd == 0) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.setPixelColor(7, strip.Color(2, 2, 0));
    strip.setPixelColor(8, strip.Color(2, 0, 0));
    strip.show();
  } 
   if(ft == 2 && nd == 5) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.setPixelColor(7, strip.Color(2, 2, 0));
    strip.setPixelColor(8, strip.Color(2, 0, 0));
    strip.setPixelColor(9, strip.Color(4, 2, 2));
    strip.show();
  } 
   if(ft == 3 && nd == 0) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.setPixelColor(7, strip.Color(2, 2, 0));
    strip.setPixelColor(8, strip.Color(2, 0, 0));
    strip.setPixelColor(9, strip.Color(4, 2, 2));
    strip.setPixelColor(10, strip.Color(2, 4, 2));
    strip.show();
  } 
   if(ft == 3 && nd == 5) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.setPixelColor(7, strip.Color(2, 2, 0));
    strip.setPixelColor(8, strip.Color(2, 0, 0));
    strip.setPixelColor(9, strip.Color(4, 2, 2));
    strip.setPixelColor(10, strip.Color(2, 4, 2));
    strip.setPixelColor(11, strip.Color(2, 2, 4));
    strip.show();
  } 
   if(ft == 4 && nd == 0) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.setPixelColor(7, strip.Color(2, 2, 0));
    strip.setPixelColor(8, strip.Color(2, 0, 0));
    strip.setPixelColor(9, strip.Color(4, 2, 2));
    strip.setPixelColor(10, strip.Color(2, 4, 2));
    strip.setPixelColor(11, strip.Color(2, 2, 4));
    strip.setPixelColor(12, strip.Color(0, 2, 0));
    strip.show();
  } 
   if(ft == 4 && nd == 5) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.setPixelColor(7, strip.Color(2, 2, 0));
    strip.setPixelColor(8, strip.Color(2, 0, 0));
    strip.setPixelColor(9, strip.Color(4, 2, 2));
    strip.setPixelColor(10, strip.Color(2, 4, 2));
    strip.setPixelColor(11, strip.Color(2, 2, 4));
    strip.setPixelColor(12, strip.Color(0, 2, 0));
    strip.setPixelColor(13, strip.Color(4, 2, 4));
    strip.show();
  } 
   if(ft == 5 && nd == 0) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.setPixelColor(7, strip.Color(2, 2, 0));
    strip.setPixelColor(8, strip.Color(2, 0, 0));
    strip.setPixelColor(9, strip.Color(4, 2, 2));
    strip.setPixelColor(10, strip.Color(2, 4, 2));
    strip.setPixelColor(11, strip.Color(2, 2, 4));
    strip.setPixelColor(12, strip.Color(0, 2, 0));
    strip.setPixelColor(13, strip.Color(4, 2, 4));
    strip.setPixelColor(14, strip.Color(4, 4, 2));
    strip.show();
  } 
   if(ft == 5 && nd == 5) {
    strip.setPixelColor(16, c);
    strip.setPixelColor(17, strip.Color(2, 0, 2));
    strip.setPixelColor(18, strip.Color(0, 2, 2));
    strip.setPixelColor(7, strip.Color(2, 2, 0));
    strip.setPixelColor(8, strip.Color(2, 0, 0));
    strip.setPixelColor(9, strip.Color(4, 2, 2));
    strip.setPixelColor(10, strip.Color(2, 4, 2));
    strip.setPixelColor(11, strip.Color(2, 2, 4));
    strip.setPixelColor(12, strip.Color(0, 2, 0));
    strip.setPixelColor(13, strip.Color(4, 2, 4));
    strip.setPixelColor(14, strip.Color(4, 4, 2));
    strip.setPixelColor(15, strip.Color(0, 0, 2));
    strip.show();
  }
}
void colorWipeSmall(uint32_t c, uint8_t st) {
  if(st == 0) {
    strip.setPixelColor(4, c);
    strip.setPixelColor(1, 0);
    strip.setPixelColor(2, 0);
    strip.setPixelColor(3, 0);
    strip.setPixelColor(5, 0);
    strip.setPixelColor(6, 0);
    strip.show();
  } 
  if(st == 1) {
    strip.setPixelColor(5, c);
    strip.show();
  } 
  if(st == 2) {
    strip.setPixelColor(6, c);
    strip.show();
  } 
  if(st == 3) {
    strip.setPixelColor(1, c);
    strip.show();
  } 
  if(st == 4) {
    strip.setPixelColor(2, c);
    strip.show();
  } 
  if(st == 5) {
    strip.setPixelColor(3, c);
    strip.show();
  } 
  strip.setPixelColor(0, strip.Color(4, 5, 5));
  strip.show();
  delay(1000);
  strip.setPixelColor(0, 0);
  strip.show();
}
